#!/usr/bin/perl -w
## ######### PROJECT NAME : ##########
## 
## Lib_Log.pm for wishmin
## 
## ######### PROJECT DESCRIPTION : ###
## 
## this library brings log tools for wishmin
## 
## ###################################
## 
## Made by Boutonnet Alexandre
## Email   <aboutonnet@intellique.com>
## 
## Started on  Mon May 18 13:56:58 2009 Boutonnet Alexandre
## Last update Mon May 18 15:11:39 2009 Boutonnet Alexandre
## 
## ###################################
##

package Lib_Log;

use INTLIQ::Logger;

my $CONFIG_FILE = "etc/wishmin.conf";
my $LOGGER_INSTANCE = 0;

sub get_obj_instance
{
    return (0, $LOGGER_INSTANCE)
	if ($LOGGER_INSTANCE && ref($conf->{LOGGER}) eq "INTLIQ::Logger");

    my $log_file = _get_log_file_location();

    # Test if the log file is writable
    return (1, "Unable to open $log_file log file")
	if (! -w $log_file && -f $log_file);

    my ($ret_code, $instance) = new INTLIQ::Logger($log_file);

    # save the instance in my global-constant var
    $LOGGER_INSTANCE = $instance if (!$ret_code);

    return ($ret_code, $instance);
}

sub _get_log_file_location
{
    my $log_location = `grep -v -e "^#" $CONFIG_FILE | grep log_file | cut -f 2 -d '='`;

    return ("/tmp/wishmin.log") if (!$log_location);
    
    chomp $log_location;
    $log_location =~ s/ //g if ($log_location =~ m/^\s*[\D\/]+/);
    
    return ($log_location);
}

1;
